/***************************************************************************
                          board.h  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 1999                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef BOARD_H
#define BOARD_H

#include <qpoint.h>

#include "move.h"


/**
  *@author Sung Soo Kang
  */

class Board {
public: 
	Board();
	Board(int);
	~Board();
	int board[11][11];
	int dim;
	int blockId;
	int openId;
	
	void initBoard();
	void setSpot(int, int, int);
	int getSpot(int, int);
	
	int isLegalMove(Move *, int);
	int isGameOver();
	int isOnBoard(int, int);
	int isOpen(int, int);
	int isBlock(int, int);
	int isEnemy(int, int, int);
	int isGoingToWall(Move *);
	int advanceMove(Move *, int);
	int possibleMoveExists(int);
	int advanceLegalMove(Move *, int);
};

#endif














