/***************************************************************************
                          kvirusview.cpp  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 00:50:22 PDT 1999
                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : sskang@po-box.mcgill.ca                                     
 ***************************************************************************/
/***************************************************************************
  The original vergion of Kvirus is Ataxxlet written in JAVA
    by Paul Buchheit <ptb@po.cwru.edu>
  Kvirus is KDE port of Ataxxlet.
****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include <kvirusview.h>
#include <kdir.h>
#include <stdlib.h>

QString icondir = KApplication::kde_datadir()+"/kvirus/pics/";
QString audiodir = KApplication::kde_datadir()+"/kvirus/sounds/";

int randGen(int d);

KvirusView::KvirusView(KApplication* a,KvirusDoc* doc,QWidget *parent) //test
	: QWidget(parent){
	dim=9;
	b = new Board(dim);
	human= new Player(b,1);
  computer=new Player(b,2);
  initBoard();
	timer = new QTimer(this);
  connect(timer, SIGNAL(timeout()), SLOT(computerMove()) );
  setGamemode(0);
  setGameFlag(0);
  setSoundMode(1);
	this->resize(34*dim, 39*dim);
	setPixmaps();

}

KvirusView::~KvirusView(){
}


///////////////////////////
void KvirusView::drawCircle(int i, int j, QPixmap pix){
  QPainter p;
  QPoint point(hole_begin+i*small_width, j*small_width_y);
  p.begin(this);
  p.drawPixmap(point, pix);
  p.flush();
  p.end();
}

void KvirusView::mousePressEvent(QMouseEvent *point){
  int x, y;
  x=point->x()/small_width;
  y=point->y()/small_width_y;
  if(isHumanTurn()&& !isGameOver()){
		boardClick(human, x, y);
	}
	else if(!isHumanTurn() && (gameMode()==1 && !isGameOver()))
		boardClick(computer, x, y);
	
}

void KvirusView::boardClick(Player *p, int x, int y){
    if(!isClicked() && !b->isEnemy(p->getplayer(), x, y) && !b->isOpen(x, y) &&!b->isBlock(x, y)){
      setClicked(1);
      p->m->setfromX(x);
      p->m->setfromY(y);
      if(p->getplayer()==1)
      	drawCircle(x, y, rspix);
      else
      	drawCircle(x, y, bspix);
    }
    else if (isClicked()){
      if((p->m->getfromX()==x) && (p->m->getfromY()==y)){
        setClicked(0);
        if(p->getplayer()==1)
        	drawCircle(x,y, rpix);
				else
					drawCircle(x, y, bpix);
      }
      else{
        p->m->settoX(x);
        p->m->settoY(y);
        playerMove(p);
        if(gameMode()==0)
        	timer->start(200, TRUE);
      }
    }
}

void KvirusView::setGamemode(int mode){
	this->gamemode=mode;
}

int KvirusView::gameMode(){
	return gamemode;
}

void KvirusView::paintEvent(QPaintEvent *){
  p.begin(this);
  p.fillRect(0, 0, window_width, window_height, gray);
  p.end();
  for(int i=0;i<dim; i++)
    for(int j=0;j<dim;j++){
      drawCircle(i, j, gpix);
    }
  for(int i=0; i<dim; i++){
    for(int j=0; j<dim; j++){
      if(b->getSpot(i, j) != 0){
        if(b->getSpot(i, j)==1)
          drawCircle(i, j, rpix);
        else if(b->getSpot(i, j)==2)
          drawCircle(i, j, bpix);
        else if(b->getSpot(i, j)==3)
          drawCircle(i, j, blpix);
      }
    }
  }
}

void KvirusView::initBoard(){

  setGameFlag(1);
  setHumanTurn(1);
  setClicked(0);
  setBlockFlag(1);
  window_width=34*dim;
  window_height=39*dim;
  small_width=int(window_width/dim);
  small_width_y=int((window_height)/dim);
  stone_width=int(.99*small_width);
  stone_height=int(.99*small_width_y);
  hole_begin=int((small_width-stone_width)/2);


  b->setSpot(0,0, 1);
  b->setSpot(dim-1,dim-1, 1);
  b->setSpot(dim-1,0, 2);
  b->setSpot(0,dim-1, 2);

  if(isBlockFlag()){
  	setBlocks();
  }

}

void KvirusView::resizeEvent(QResizeEvent *r){
  QSize s= r->size();
  window_width=s.width();
  window_height=s.height();
  small_width=int(this->width()/dim);
  small_width_y=int((this->height())/dim);
  stone_width=int(.99*small_width);
  stone_height=int(.99*small_width_y);
  hole_begin=int((small_width-stone_width)/2);
}


void KvirusView::eat_enemy(Player *pl){
  QPixmap pix;
  int i, j;
  if(pl->m->distance() > 1){
    b->setSpot(pl->m->getfromX(),pl->m->getfromY(),0);
    drawCircle(pl->m->getfromX(),pl->m->getfromY(), gpix);
  }
  if(pl->player==1){
		pix=rpix;
  }
  else if(pl->player==2){
    pix=bpix;
  }
  for(i=-1;i<=1;i++)
    for(j=-1;j<=1;j++){
      if(b->isOnBoard(pl->m->gettoX()+i,pl->m->gettoY()+j) && b->isEnemy(pl->player, pl->m->gettoX()+i,pl->m->gettoY()+j)){
			  b->setSpot(pl->m->gettoX()+i,pl->m->gettoY()+j,pl->player);
				if(pl->player==1){
				playSound("red.wav");
        drawCircle(pl->m->gettoX()+i,pl->m->gettoY()+j, pix);
				}
				else{
				playSound("blue.wav");
        drawCircle(pl->m->gettoX()+i,pl->m->gettoY()+j, pix);
				}
    }
	}	
}

void KvirusView::score_report(){
  int i, x, y;
  int score[2];
  char result[80];
  char msg[80];
  if(isGameOver()){
  	return;
  }
  for(i=0;i<2;i++)
    score[i]=0;
  for(x=0;x<dim;x++)
    for(y=0;y<dim;y++){
      if((b->getSpot(x, y) > 0) && (b->getSpot(x, y) < 3))
        score[b->getSpot(x, y)-1]+=1;
    }
  if(score[0]>score[1]){
  	if(gameMode()==0)
  		qstrcpy(msg,"AAAAAArg... You beat me!\n");
  	playSound("ahhhh.wav");
	
 	}
  else if(score[0]<score[1]){
  	if(gameMode()==0)
    	qstrcpy(msg,"HeHeHe... You lost.. I got ya!!\n");
    playSound("lost.wav");
  }
  if(gameMode()==0){
  	sprintf(result,"Your Score is %d and My Score is %d", score[0], score[1]);
 	 	strncat(msg, result, 40);
 	}
 	else if(gameMode()==1)
 		sprintf(msg,"Player Red : %d and Player Blue: %d", score[0], score[1]);
  KMsgBox::message(this, "Game Over", msg, 0,0);
	setGameFlag(1);
}

void KvirusView::setBlocks(){
	int x, y, z;
	z=dim-5;
 	for(int i=0;i<z;i++){
 		x=randGen(dim);
 		y=randGen(dim);
   	b->setSpot(x,y,3);
  }

}

void KvirusView::fillAll(Player *p){
	p->m->resetMove();
	while(b->possibleMoveExists(p->getplayer())){
		p->m=p->findBestMove();
		playerMove(p);
	}
}

void KvirusView::computerMove(){
  if(!isHumanTurn()){
    computer->m->resetMove();
    do{
        if(b->possibleMoveExists(2)){
          computer->m=computer->findBestMove();
        if(playerMove(computer))
          continue;
        }
        else if(!b->possibleMoveExists(1)){
          score_report();
          setGameFlag(0);
          break;
        }
    }while(!b->possibleMoveExists(1));
  }
  setHumanTurn(1);
}

bool KvirusView::playerMove(Player *pl){
  if(!isGameOver() && b->isLegalMove(pl->m, pl->getplayer())){
    if(pl->getplayer()==1){
      b->setSpot(pl->m->gettoX(), pl->m->gettoY(), 1);
      drawCircle(pl->m->getfromX(), pl->m->getfromY(), rpix);
  		playSound("red.wav");
      drawCircle(pl->m->gettoX(),pl->m->gettoY(), rpix);
      setClicked(0);
      eat_enemy(pl);
      if(b->possibleMoveExists(2))
      	setHumanTurn(0);
      else{
      	fillAll(pl);
      	score_report();
      }
    }
    else if(pl->getplayer()==2){
      b->setSpot(pl->m->gettoX(), pl->m->gettoY(), 2);
      drawCircle(pl->m->getfromX(), pl->m->getfromY(), bpix);
      playSound("blue.wav");
      drawCircle(pl->m->gettoX(),pl->m->gettoY(), bpix);
      setClicked(0);
      eat_enemy(pl);
      if(gameMode()==1){
      	if(b->possibleMoveExists(1))
					setHumanTurn(1);
				else{
					fillAll(pl);
					score_report();
				}
			}
		
		return(1);
    }
  }
  else{
    if(pl->getplayer()==1){
      setClicked(0);
      playSound("neg.wav");
      drawCircle(pl->m->getfromX(), pl->m->getfromY(), rpix);
      return(0);
    }
    else if(pl->getplayer()==2)
    	setClicked(0);
    	playSound("neg.wav");
    	drawCircle(pl->m->getfromX(), pl->m->getfromY(), bpix);
      return(0);
  }
  return(0);
}

void KvirusView::newGame(){
	b = new Board(dim);
	human= new Player(b,1);
  computer=new Player(b,2);

  setGameFlag(1);
  setHumanTurn(1);

  p.begin(this);
  p.fillRect(0, 0, this->width(), this->height(), gray);
  p.end();

  for(int i=0;i<dim; i++){
    for(int j=0;j<dim;j++){
      b->setSpot(i, j, 0);
      drawCircle(i, j, gpix);
    }
  }
  b->setSpot(0, 0, 1);
  b->setSpot(dim-1, dim-1, 1);
  b->setSpot(dim-1, 0, 2);
  b->setSpot(0, dim-1, 2);

	if(isBlockFlag()){
		setBlocks();
  }
  this->update();
}

void KvirusView::setBlockFlag(int flag){
  this->blockflag=flag;
}

int KvirusView::isBlockFlag(){
  return(blockflag);
}

int KvirusView::isClicked(){
  return(clickflag);
}

void KvirusView::setClicked(int flag){
  clickflag=flag;
}

int KvirusView::isHumanTurn(){
  return(moveflag);
}

int KvirusView::isSoundOn(){
	return(soundflag);
}

void KvirusView::setGameFlag(int flag){
  gameflag=flag;
}

int KvirusView::isGameOver(){
  return gameflag;
}

void KvirusView::setHumanTurn(int flag){
  moveflag=flag;
}

void KvirusView::setPixmaps(){
	KDir kdir;
	QString curdir(kdir.path());
	if(!gpix.load(icondir+"/virus_gray.xpm"))
    gpix.load(curdir+"pics/virus_gray.xpm");
  if(!rpix.load(icondir+"/virus_r.xpm"))
    rpix.load("pics/virus_r.xpm");
  if(!bpix.load(icondir+"/virus_b.xpm"))
    bpix.load("pics/virus_b.xpm");
	if(!rspix.load(icondir+"/virus_r_s.xpm"))
        rspix.load("pics/virus_r_s.xpm");
  if(!blpix.load(icondir+"/block.xpm"))
    blpix.load("pics/block.xpm");
	if(!bspix.load(icondir+"/virus_b_s.xpm"))
    bspix.load("pics/virus_b_s.xpm");
}	

void KvirusView::setSoundMode(int i){
	this->soundflag=i;
}

void KvirusView::playSound(QString filename){
		KDir kdir;
		if(isSoundOn()&&!audio.serverStatus()){
			QString curdir(kdir.path());
			audio.play(audiodir+filename);
			audio.sync();
		}
}

int randGen(int d){
	int result;
	result=1+(rand()%(d-2));
	return(result);
}	


















