/***************************************************************************
                          kvirusview.h  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 00:50:22 PDT 1999
                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef KVIRUSVIEW_H 
#define KVIRUSVIEW_H 

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <kapp.h>
#include <kmsgbox.h>
#include <kaudio.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qbrush.h>
#include <qpixmap.h>
#include <qtimer.h>

#include "kvirusdoc.h"
#include "player.h"
/**
*This class provides main view of Kvirus
*/

class KvirusView : public QWidget
{
  Q_OBJECT

 public:
  /** Constructor for the main view */
  KvirusView(KApplication* a=0,KvirusDoc* doc=0,QWidget *parent = 0); //test
  /** Destructor for the main view */
  ~KvirusView();

  Board *b; //Kvirus Views Main Board
  Player *human; // Human Player
  Player *computer; // Computer Player
	KAudio audio; //KAudio Server connecter

/** Window properties*/
/** View Window widht and height*/
  short menuheight;
  int window_width;
  int window_height;
  /** Block size*/
  int small_width;
  int small_width_y;
  int stone_width;
  int stone_height;
  int hole_begin;
  int dim;

  /**draw pixmap to view window
	* x : x point
	* y : y point
	* QPixmap : pixmap
  */
  void drawCircle(int, int, QPixmap);
  /** Intialize Board and window position*/
  void initBoard();
	/** View Window basic events handling*/
  void mousePressEvent(QMouseEvent *);
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);


  int gameflag;
  int clickflag;
  int moveflag;
  int blockflag;
  int gamemode;
  int soundflag;
  float score;

  void score_report();
  bool playerMove(Player *);
  void newGame();

  void setBlockFlag(int);
  int isBlockFlag();
  int isClicked();
  void setClicked(int);
  int isHumanTurn();
  void setHumanTurn(int); // set game turn to human turn.
  void setGameFlag(int); // set game flag to game over or not
  int isGameOver(); //check if game is over

  KvirusDoc *doc;

  void setPixmaps(); // set all pixmaps needed by KvirusView
	void playSound(QString);	
	
	void boardClick(Player *, int, int);
	void setGamemode(int);
	int gameMode();
	void fillAll(Player *);	
	void setBlocks();
	void setSoundMode(int);
	int isSoundOn();
	
	
 public slots:
  void computerMove(); // Computer's move :subject to change
  void eat_enemy(Player *); // When player/computer encounter enemy virus, eat them.

 private:
 	QTimer *timer; //Player Turn Timer
	QPainter p;	//KvirusView Painer pointer
  QPixmap rpix; // Red virus pixmap
  QPixmap bpix; // Blue virus pixmap
  QPixmap bspix;
  QPixmap gpix; // Green virus pixmap : not used yet
	QPixmap rspix; // Red Shadowed pixmap
	QPixmap blpix;	// Block pixmap
};

#endif // KVIRUSVIEW_H 










































